' API-based sound output for Visual Basic.  Version 1.2, by Neil Fraser, October 96.
' Based on code from "The Visual Guide to Visual Basic for Windows" by Richard Mansfield.
Declare Function OpenSound% Lib "sound.drv" ()
Declare Function SetVoiceSound% Lib "sound.drv" (ByVal nSource%, ByVal Freq&, ByVal nDuration%)
Declare Function StartSound% Lib "sound.drv" ()
Declare Function CloseSound% Lib "sound.drv" ()
Declare Function WaitSoundState% Lib "sound.drv" (ByVal State%)

' Plays a musical note ("A, A#, B ... F#, G, G#")
' At a particular octave (0, 1, 2, 3 ...)
' For a number of ticks (400 ticks per second)
'
Sub play_note (note$, octave%, ticks%)
  Dim hertz&
  Select Case UCase$(note$)
    Case "C": hertz& = 262
    Case "C#": hertz& = 272
    Case "D": hertz& = 294
    Case "D#": hertz& = 314
    Case "E": hertz& = 330
    Case "F": hertz& = 350
    Case "F#": hertz& = 370
    Case "G": hertz& = 392
    Case "G#": hertz& = 419
    Case "A": hertz& = 440
    Case "A#": hertz& = 475
    Case "B": hertz& = 494
    Case Else: hertz& = 0
  End Select
  
  hertz& = hertz& * (2 ^ (octave% - 2))
  sound hertz&, ticks%
End Sub

' Generates a sound through the computer's speaker.
'   frequency    The desired frequency of the sound,
'                measured in hertz (cycles/second).
'   duration     The desired duration of the sound,
'                there are 400 ticks per second.)
'
Sub sound (frequency&, duration%)
  t = OpenSound()
  t = SetVoiceSound(1, (frequency& * 65536), duration%)
  t = StartSound()
  While (WaitSoundState(0) <> 0): Wend
  t = CloseSound()
  
  'Double hertz for each octave up, halve for each octave down
  ' C  = 262 hertz  |  F# = 370 hertz
  ' C# = 272 hertz  |  G  = 392 hertz
  ' D  = 294 hertz  |  G# = 419 hertz
  ' D# = 314 hertz  |  A  = 440 hertz
  ' E  = 330 hertz  |  A# = 475 hertz
  ' F  = 350 hertz  |  B  = 494 hertz
End Sub

